VERSION 5.00
Begin VB.UserControl FBIShapeProgressBar 
   Alignable       =   -1  'True
   CanGetFocus     =   0   'False
   ClientHeight    =   195
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4005
   PropertyPages   =   "FBIShapeProgressBar.ctx":0000
   ScaleHeight     =   195
   ScaleWidth      =   4005
   ToolboxBitmap   =   "FBIShapeProgressBar.ctx":0023
   Begin VB.Label Avanzamento3 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "100 %"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H8000000E&
      Height          =   195
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   4000
   End
   Begin VB.Shape Avanzamento2 
      BackColor       =   &H8000000D&
      BackStyle       =   1  'Opaque
      Height          =   200
      Left            =   0
      Top             =   0
      Width           =   3000
   End
   Begin VB.Shape Avanzamento1 
      BackStyle       =   1  'Opaque
      Height          =   200
      Left            =   0
      Top             =   0
      Width           =   4000
   End
End
Attribute VB_Name = "FBIShapeProgressBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'Valori predefiniti propriet:
Const DefaultMin = 0
Const DefaultMax = 100
Const DefaultValue = 0
Const DefaultDecimali = 0
'Variabili propriet:
Dim InternoMin As Double
Dim InternoMax As Double
Dim InternoValue As Double
Dim InternoDecimali As Integer
'Dichiarazioni di eventi:
Public Event Change()
Attribute Change.VB_Description = "Evento generato ad ogni cambio della propriet Value."
Public Event Minimo()
Attribute Minimo.VB_Description = "Evento generato quando la propriet Value raggiunge il valore Min."
Public Event Massimo()
Attribute Massimo.VB_Description = "Evento generato quando la propriet Value raggiunge il valore Max."
Public Event Errore(ByRef MostraErrore As Boolean)
Attribute Errore.VB_Description = "Evento generato ad ogni impostazione errata."

Public Property Get Alignment() As AlignmentConstants
Attribute Alignment.VB_Description = "Restituisce ed imposta l'allineamento del testo."
Attribute Alignment.VB_ProcData.VB_Invoke_Property = ";Testo"
    Alignment = Avanzamento3.Alignment
End Property

Public Property Let Alignment(ByVal New_Alignment As AlignmentConstants)
    Avanzamento3.Alignment() = New_Alignment
    PropertyChanged "Alignment"
End Property

Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Restituisce o imposta il colore per la barra di sfondo."
Attribute BackColor.VB_ProcData.VB_Invoke_Property = "StandardColor;Aspetto"
Attribute BackColor.VB_UserMemId = -501
    BackColor = Avanzamento1.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    Avanzamento1.BackColor() = New_BackColor
    PropertyChanged "BackColor"
End Property

Public Property Get BorderColor() As OLE_COLOR
Attribute BorderColor.VB_Description = "Restituisce ed imposta il colore del bordo della barra di avanzamento."
Attribute BorderColor.VB_ProcData.VB_Invoke_Property = "StandardColor;Aspetto"
Attribute BorderColor.VB_UserMemId = -503
    BorderColor = Avanzamento1.BorderColor
End Property

Public Property Let BorderColor(ByVal New_BorderColor As OLE_COLOR)
    Avanzamento1.BorderColor() = New_BorderColor
    Avanzamento2.BorderColor() = New_BorderColor
    PropertyChanged "BorderColor"
End Property

Public Property Get BorderStyle() As BorderStyleConstants
Attribute BorderStyle.VB_Description = "Restituisce ed imposta lo stile del bordo della barra di avanzamento."
Attribute BorderStyle.VB_ProcData.VB_Invoke_Property = ";Aspetto"
Attribute BorderStyle.VB_UserMemId = -504
    BorderStyle = Avanzamento1.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As BorderStyleConstants)
    Avanzamento1.BorderStyle = New_BorderStyle
    Avanzamento2.BorderStyle = New_BorderStyle
    PropertyChanged "BorderStyle"
End Property

Public Property Get Caption() As String
Attribute Caption.VB_Description = "Restituisce il testo contenuto nella barra di avanzamento."
Attribute Caption.VB_ProcData.VB_Invoke_Property = ";Testo"
Attribute Caption.VB_UserMemId = -518
    Caption = Avanzamento3.Caption
End Property

Public Property Get Decimali() As Variant
Attribute Decimali.VB_Description = "Restituisce ed imposta il numero di cifre decimali da visualizzare nella propriet Caption."
Attribute Decimali.VB_ProcData.VB_Invoke_Property = ";Dati"
    Decimali = InternoDecimali
End Property

Public Property Let Decimali(ByVal New_Decimali As Variant)
    InternoDecimali = New_Decimali
    PropertyChanged "Decimali"
    RicalcolaValore
    RaiseEvent Change
End Property

Public Property Get Font() As Font
Attribute Font.VB_Description = "Restituisce ed imposta il tipo di carattere utilizzato per la Caption della barra di avanzamento."
Attribute Font.VB_ProcData.VB_Invoke_Property = "StandardFont;Carattere"
Attribute Font.VB_UserMemId = -512
    Set Font = Avanzamento3.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set Avanzamento3.Font = New_Font
    PropertyChanged "Font"
End Property

Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Restituisce ed imposta il colore della barra principale."
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = "StandardColor;Aspetto"
Attribute ForeColor.VB_UserMemId = -513
    ForeColor = Avanzamento2.BackColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    Avanzamento2.BackColor() = New_ForeColor
    PropertyChanged "ForeColor"
End Property

Public Property Get Max() As Double
Attribute Max.VB_Description = "Restituisce ed imposta il valore massimo per la barra di avanzamento."
Attribute Max.VB_ProcData.VB_Invoke_Property = ";Dati"
    Max = InternoMax
End Property

Public Property Let Max(ByVal New_Max As Double)
    Dim MostraErrore As Boolean
    If New_Max < InternoMin Then
        MostraErrore = True
        RaiseEvent Errore(MostraErrore)
        If MostraErrore = True Then MsgBox "Errore nell'impostazione della propriet Max", vbCritical + vbOKOnly, "FProgressBar"
    Else
        InternoMax = New_Max
        PropertyChanged "Max"
        If InternoValue > InternoMax Then
            InternoValue = InternoMax
            RaiseEvent Change
            RaiseEvent Massimo
        End If
        RicalcolaValore
    End If
End Property

Public Property Get Min() As Double
Attribute Min.VB_Description = "Restituisce ed imposta il valore minimo per la barra di avanzamento."
Attribute Min.VB_ProcData.VB_Invoke_Property = ";Dati"
    Min = InternoMin
End Property

Public Property Let Min(ByVal New_Min As Double)
    Dim MostraErrore As Boolean
    If New_Min > InternoMax Then
        MostraErrore = True
        RaiseEvent Errore(MostraErrore)
        If MostraErrore = True Then MsgBox "Errore nell'impostazione della propriet Min", vbCritical + vbOKOnly, "FProgressBar"
    Else
        InternoMin = New_Min
        PropertyChanged "Min"
        If InternoValue < InternoMin Then
            InternoValue = InternoMin
            RaiseEvent Change
            RaiseEvent Minimo
        End If
        RicalcolaValore
    End If
End Property

Public Property Get MouseIcon() As Picture
Attribute MouseIcon.VB_Description = "Restituisce ed imposta un puntatore personalizzato per la barra di avanzamento."
Attribute MouseIcon.VB_ProcData.VB_Invoke_Property = "StandardPicture;Aspetto"
    Set MouseIcon = Avanzamento3.MouseIcon
End Property

Public Property Set MouseIcon(ByVal New_MouseIcon As Picture)
    UserControl.MouseIcon = New_MouseIcon
    Set Avanzamento3.MouseIcon = New_MouseIcon
    PropertyChanged "MouseIcon"
End Property

Public Property Get MousePointer() As MousePointerConstants
Attribute MousePointer.VB_Description = "Restituisce ed imposta il tipo di puntatore visualizzato sulla barra di avanzamento."
Attribute MousePointer.VB_ProcData.VB_Invoke_Property = ";Aspetto"
    MousePointer = Avanzamento3.MousePointer
End Property

Public Property Let MousePointer(ByVal New_MousePointer As MousePointerConstants)
    UserControl.MousePointer() = New_MousePointer
    Avanzamento3.MousePointer() = New_MousePointer
    PropertyChanged "MousePointer"
End Property

Public Property Get TextColor() As OLE_COLOR
Attribute TextColor.VB_Description = "Restituisce ed imposta il colore del testo della barra di avanzamento."
Attribute TextColor.VB_ProcData.VB_Invoke_Property = "StandardColor;Aspetto"
    TextColor = Avanzamento3.ForeColor
End Property

Public Property Let TextColor(ByVal New_TextColor As OLE_COLOR)
    Avanzamento3.ForeColor() = New_TextColor
    PropertyChanged "TextColor"
End Property

Public Property Get Value() As Double
Attribute Value.VB_Description = "Restituisce ed imposta il valore corrente della barra di avanzamento."
Attribute Value.VB_ProcData.VB_Invoke_Property = ";Dati"
Attribute Value.VB_UserMemId = 0
Attribute Value.VB_MemberFlags = "200"
    Value = InternoValue
End Property

Public Property Let Value(ByVal New_Value As Double)
    Dim VecchioValue As Long
    Dim MostraErrore As Boolean
    If (New_Value < InternoMin) Or (New_Value > InternoMax) Then
        MostraErrore = True
        RaiseEvent Errore(MostraErrore)
        If MostraErrore = True Then MsgBox "Errore nell'impostazione della propriet Value", vbCritical + vbOKOnly, "FProgressBar"
    Else
        VecchioValue = InternoValue
        InternoValue = New_Value
        PropertyChanged "Value"
        If New_Value <> VecchioValue Then RaiseEvent Change
        If New_Value = InternoMin Then RaiseEvent Minimo
        If New_Value = InternoMax Then RaiseEvent Massimo
        RicalcolaValore
    End If
End Property

Public Function Percentuale(Optional CifreDecimali As Integer) As Double
Attribute Percentuale.VB_Description = "Restituisce il valore percentuale della barra di avanzamento."
    On Error GoTo Errore
    If CifreDecimali <= 0 Then
        Percentuale = Int((InternoValue - InternoMin) / (InternoMax - InternoMin) * 100)
    Else
        Percentuale = CDbl(Format((InternoValue - InternoMin) / (InternoMax - InternoMin) * 100, "##." & String(CifreDecimali, "0")))
    End If
    Exit Function
Errore:
    If CifreDecimali <= 0 Then
        Percentuale = 0
    Else
        Percentuale = CDbl(Format(0, "##." & String(CifreDecimali, "0")))
    End If
End Function

Private Sub UserControl_Initialize()
    RicalcolaValore
End Sub

Private Sub UserControl_InitProperties()
    InternoMin = DefaultMin
    InternoMax = DefaultMax
    InternoValue = DefaultValue
    InternoDecimali = DefaultDecimali
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Avanzamento3.Alignment = PropBag.ReadProperty("Alignment", 2)
    Avanzamento1.BackColor = PropBag.ReadProperty("BackColor", &H80000005)
    Avanzamento1.BorderColor = PropBag.ReadProperty("BorderColor", -2147483640)
    Avanzamento1.BorderStyle = PropBag.ReadProperty("BorderStyle", 1)
    Avanzamento2.BorderStyle = PropBag.ReadProperty("BorderStyle", 1)
    Avanzamento3.Caption = PropBag.ReadProperty("Caption", "100 %")
    Set Font = PropBag.ReadProperty("Font", Ambient.Font)
    Avanzamento2.BackColor = PropBag.ReadProperty("ForeColor", &H8000000D)
    Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
    Avanzamento3.MousePointer = PropBag.ReadProperty("MousePointer", 0)
    InternoMin = PropBag.ReadProperty("Min", DefaultMin)
    InternoMax = PropBag.ReadProperty("Max", DefaultMax)
    InternoValue = PropBag.ReadProperty("Value", DefaultValue)
    Avanzamento3.ForeColor = PropBag.ReadProperty("TextColor", &H8000000E)
    InternoDecimali = PropBag.ReadProperty("Decimali", DefaultDecimali)
    RicalcolaValore
End Sub

Private Sub UserControl_Resize()
    Call Avanzamento1.Move(0, 0, UserControl.Width - 1, UserControl.Height)
    Call Avanzamento2.Move(0, 0, UserControl.Width - 1, UserControl.Height)
    Call Avanzamento3.Move(0, (UserControl.Height - TextHeight(Avanzamento3.Caption)) / 2, UserControl.Width - 30, UserControl.Height)
    RicalcolaValore
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("Alignment", Avanzamento3.Alignment, 2)
    Call PropBag.WriteProperty("BackColor", Avanzamento1.BackColor, &H80000005)
    Call PropBag.WriteProperty("BorderColor", Avanzamento1.BorderColor, -2147483640)
    Call PropBag.WriteProperty("BorderStyle", Avanzamento1.BorderStyle, 1)
    Call PropBag.WriteProperty("Caption", Avanzamento3.Caption, "100 %")
    Call PropBag.WriteProperty("Font", Font, Ambient.Font)
    Call PropBag.WriteProperty("ForeColor", Avanzamento2.BackColor, &H8000000D)
    Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
    Call PropBag.WriteProperty("MousePointer", Avanzamento3.MousePointer, 0)
    Call PropBag.WriteProperty("Min", InternoMin, DefaultMin)
    Call PropBag.WriteProperty("Max", InternoMax, DefaultMax)
    Call PropBag.WriteProperty("Value", InternoValue, DefaultValue)
    Call PropBag.WriteProperty("TextColor", Avanzamento3.ForeColor, &H8000000E)
    Call PropBag.WriteProperty("Decimali", InternoDecimali, DefaultDecimali)
End Sub

Private Sub RicalcolaValore()
    If InternoDecimali <= 0 Then
        Avanzamento3.Caption = Percentuale(InternoDecimali) & " %"
    Else
        Avanzamento3.Caption = Format(Percentuale(InternoDecimali), "0." & String(InternoDecimali, "0")) & " %"
    End If
    Avanzamento2.Width = Avanzamento1.Width * Percentuale / 100
End Sub
