Attribute VB_Name = "Module1"
'Sezione Win2K / Xp per Aquisire privilegi e spegnere
Public TimeOutCnt As Integer
Public Const TOKEN_ADJUST_PRIVILEGES = &H20
Public Const TOKEN_QUERY = &H8
Public Const SE_PRIVILEGE_ENABLED = &H2
Public Const ANYSIZE_ARRAY = 1
Public Const VER_PLATFORM_WIN32_NT = 2
Public Const ERROR_NOT_ALL_ASSIGNED = 1300&
Public Const SE_SHUTDOWN_NAME = "SeShutdownPrivilege"

Type OSVERSIONINFO
     dwOSVersionInfoSize As Long
     dwMajorVersion As Long
     dwMinorVersion As Long
     dwBuildNumber As Long
     dwPlatformId As Long
     szCSDVersion As String * 128
End Type

Type LUID
    LowPart As Long
    HighPart As Long
End Type

Public Type LUID_AND_ATTRIBUTES
     pLuid As LUID
     Attributes As Long
End Type

Type TOKEN_PRIVILEGES
    PrivilegeCount As Long
    Privileges(ANYSIZE_ARRAY) As LUID_AND_ATTRIBUTES
End Type

Public Declare Function GetCurrentProcess Lib "kernel32" () As Long
Public Declare Function OpenProcessToken Lib "advapi32.dll" (ByVal ProcessHandle As Long, ByVal DesiredAccess As Long, TokenHandle As Long) As Long
Public Declare Function LookupPrivilegeValue Lib "advapi32" Alias "LookupPrivilegeValueA" (ByVal lpSystemName As String, ByVal lpName As String, lpLuid As LUID) As Long
Public Declare Function AdjustTokenPrivileges Lib "advapi32" (ByVal TokenHandle As Long, ByVal DisableAllPrivileges As Long, NewState As TOKEN_PRIVILEGES, ByVal BufferLength As Long, PreviousState As TOKEN_PRIVILEGES, ReturnLength As Long) As Long
Public Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (ByRef lpVersionInformation As OSVERSIONINFO) As Long

'***************************************************
'Sezione Spegnimento connessione remota
Public Const RAS_MAXDEVICENAME = 128
Public Const RAS_MAXDEVICETYPE = 16
Public Const RAS_MAXENTRYNAME = 256
Public Const SUCCESS = 0&
Public Const RAS_RASCONNSIZE As Integer = 412

Public Type RasConn
    dwSize As Long
    hRasConn As Long
    szEntryName(RAS_MAXENTRYNAME) As Byte
    szDeviceType(RAS_MAXDEVICETYPE) As Byte
    szDeviceName(RAS_MAXDEVICENAME) As Byte
End Type
Public Declare Function RasEnumConnections Lib "RasApi32.DLL" Alias "RasEnumConnectionsA" (lprasconn As Any, lpcb As Long, lpcConnections As Long) As Long
Public Declare Function RasHangUp Lib "RasApi32.DLL" Alias "RasHangUpA" (ByVal hRasConn As Long) As Long

'*******************************************************************************************
'Icona Tray Bar
Public Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As Long) As Long

'*******************************************************************************************
'API Spegnimento win98/ME/XP/2K e Costanti
Public Declare Function ExitWindowsEx Lib "user32" (ByVal uFlags As Long, ByVal dwReserved As Long) As Long
Public Const EWX_LOGOFF = 0
Public Const EWX_SHUTDOWN = 1
Public Const EWX_REBOOT = 2
Public Const EWX_FORCE = 4
Public Const EWX_POWEROFF As Long = 8
Public Const EWX_DialUp As Long = 20
Public Const EWX_Task As Long = 21


Public Type NOTIFYICONDATA
cbSize As Long
hwnd As Long
uId As Long
uFlags As Long
uCallBackMessage As Long
hIcon As Long
szTip As String * 64
End Type

'*******************************************************************************************
'Sezione per Notifica nella Tray Bar
Public Const NIM_ADD = &H0
Public Const NIM_MODIFY = &H1
Public Const NIF_MESSAGE = &H1
Public Const NIM_DELETE = &H2
Public Const NIF_ICON = &H2
Public Const NIF_TIP = &H4
Public Const WM_MOUSEMOVE = &H200
Public Const WM_LBUTTONDOWN = &H201
Public Const WM_LBUTTONUP = &H202
Public Const WM_LBUTTONDBLCLK = &H203
Public Const WM_RBUTTONDOWN = &H204
Public Const WM_RBUTTONUP = &H205
Public Const WM_RBUTTONDBLCLK = &H206

Public Declare Function Shell_NotifyIcon Lib "shell32" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, pnid As NOTIFYICONDATA) As Boolean
'**********************************************************
'Visualizza Errori
Public Declare Function GetLastError Lib "kernel32" () As Long
Public Declare Function FormatMessage Lib "kernel32" Alias "FormatMessageA" (ByVal dwFlags As Long, lpSource As Any, ByVal dwMessageId As Long, ByVal dwLanguageId As Long, ByVal lpBuffer As String, ByVal nSize As Long, Arguments As Long) As Long
Public Sub RoutineSpegni(ByRef Chiusura As Long)
If Chiusura = EWX_DialUp Then
    Call spegniAccessoRemoto
ElseIf Chiusura = EWX_Task Then
    Call frmMain.SelezionaDakill
Else
    If IsWinNT Then
        If (Chiusura = EWX_SHUTDOWN) Or Chiusura = (EWX_SHUTDOWN Or EWX_FORCE) Then
            Chiusura = Chiusura Or EWX_POWEROFF
        End If
        Call EnableShutDown
        Call ExitWindowsEx(Chiusura, SUCCESS)
    Else
        Call ExitWindowsEx(Chiusura, SUCCESS)
    End If
End If
End Sub
Public Sub spegniAccessoRemoto()
Dim RasConn_SizeBuffer As Long, HandleConn As Long, Restituito As Byte, ConnessioniAttive As Long, i As Long
ReDim RasConType(255) As RasConn
RasConType(0).dwSize = RAS_RASCONNSIZE
RasConn_SizeBuffer = RAS_MAXENTRYNAME * RasConType(0).dwSize
ConnessioniAttive = 0
Restituito = RasEnumConnections(RasConType(0), RasConn_SizeBuffer, ConnessioniAttive)
If Restituito = SUCCESS Then
    For i = 0 To ConnessioniAttive - 1
        HandleConn = RasConType(i).hRasConn
    Next
    Restituito = RasHangUp(ByVal HandleConn)
End If
End Sub
Public Function IsWinNT() As Boolean
'/////////////////////////////////
'// Controlla che sia Windows NT / 2000 / Xp
Dim myOS As OSVERSIONINFO
myOS.dwOSVersionInfoSize = Len(myOS)
GetVersionEx myOS
IsWinNT = (myOS.dwPlatformId = VER_PLATFORM_WIN32_NT)
End Function
Public Sub EnableShutDown()
'//////////////////////////////////////
'// Setta i privilegi di shutdown per
'// questa applicazione. Se viene Avviata su Win 2k
Dim hProc As Long, hToken As Long
Dim OldTokenStuff As TOKEN_PRIVILEGES
Dim OldTokenStuffLen As Long
Dim NewTokenStuff As TOKEN_PRIVILEGES

hProc = GetCurrentProcess()
If OpenProcessToken(hProc, TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY, hToken) = 0 Then
    MsgBox "OpenProcessToken Error: " & GetLastError()
    Exit Sub
End If
'retrieve the locally unique identifier to represent the Shutdown-privilege name
If LookupPrivilegeValue(vbNullString, SE_SHUTDOWN_NAME, OldTokenStuff.Privileges(0).pLuid) = 0 Then
    MsgBox "LookupPrivilegeValue Error: " & GetLastError()
    Exit Sub
End If
NewTokenStuff = OldTokenStuff
NewTokenStuff.PrivilegeCount = 1
NewTokenStuff.Privileges(0).Attributes = SE_PRIVILEGE_ENABLED
'Enable shutdown-privilege
If AdjustTokenPrivileges(hToken, False, NewTokenStuff, Len(NewTokenStuff), OldTokenStuff, Len(OldTokenStuff)) = 0 Then
    MsgBox "AdjustTokenPrivileges Error: " & GetLastError()
    Exit Sub
End If
End Sub
Public Function ScriviVersione()
Open PathApp & "versionSP.dat" For Output As #3
Print #3, App.Major & "." & App.Minor & "." & App.Revision
Close #3
End Function

Public Function PathApp() As String
PathApp = IIf(Right$(App.Path, 1) <> "\", App.Path & "\", App.Path)
End Function
Public Sub PijaArgomenti()
Dim Argom() As String, ComEsatto As Boolean
Argom = Split(LCase$(Trim$(Command())), " ")
ComEsatto = False
If UBound(Argom) > -1 Then
    If Argom(0) = "/shutdown" Then
        frmMain.tipoChiusura = EWX_SHUTDOWN
        ComEsatto = True
    ElseIf Argom(0) = "/reboot" Then
        frmMain.tipoChiusura = EWX_REBOOT
        ComEsatto = True
    ElseIf Argom(0) = "/logoff" Then
        frmMain.tipoChiusura = EWX_LOGOFF
        ComEsatto = True
    ElseIf Argom(0) = "/dialupoff" Then
        frmMain.tipoChiusura = EWX_DialUp
        ComEsatto = True
    End If
    
    If Not ComEsatto Then
        MsgBox ("This's the argouments for Spegni Pc" & vbCrLf & _
        "Spegni Pc /[Argoument] /c" & String(2, vbCrLf) & _
        vbTab & "/Shutdown  " & vbTab & "to shutdown your pc" & vbCrLf & _
        vbTab & "/Reboot    " & vbTab & "to reboot your pc" & vbCrLf & _
        vbTab & "/LogOff    " & vbTab & "to LogOff your pc" & vbCrLf & _
        vbTab & "/DialuUpOff" & vbTab & "to Turn off your DialUp connection" & String(2, vbCrLf) & _
        vbTab & "/c" & vbTab & "to Ask confirmation to execute the selected operation"), vbInformation, "Argouments"
    Else
        If Argom(1) = "/c" Then
            frmMain.Command1.Caption = "Stop"
            frmExecute.Show vbModal
            Set frmExecute = Nothing
            End
        Else
            Call frmMain.Spegni
        End If
    End If
End If
End Sub
