Attribute VB_Name = "Modulo_Task"
Option Explicit
Private Const TH32CS_SNAPTHREAD = &H4&
Public Const TH32CS_SNAPPROCESS As Long = 2&
Public Const MAX_PATH As Integer = 260
Private Const WM_QUIT = &H12

Public Type PROCESSENTRY32
  dwSize As Long
  cntUsage As Long
  th32ProcessID As Long
  th32DefaultHeapID As Long
  th32ModuleID As Long
  cntThreads As Long
  th32ParentProcessID As Long
  pcPriClassBase As Long
  dwFlags As Long
  szExeFile As String * MAX_PATH
End Type

Private Type THREADENTRY32
    dwSize              As Long
    cntUsage            As Long
    th32ThreadID        As Long
    th32OwnerProcessID  As Long
    tpBasePri           As Long
    tpDeltaPri          As Long
    dwFlags             As Long
End Type

Public Declare Function CreateToolhelpSnapshot Lib "kernel32" Alias "CreateToolhelp32Snapshot" (ByVal lFlags As Long, ByVal lProcessID As Long) As Long
Public Declare Function ProcessFirst Lib "kernel32" Alias "Process32First" (ByVal HSnapShot As Long, uProcess As PROCESSENTRY32) As Long
Public Declare Function ProcessNext Lib "kernel32" Alias "Process32Next" (ByVal HSnapShot As Long, uProcess As PROCESSENTRY32) As Long
Public Declare Sub CloseHandle Lib "kernel32" (ByVal hPass As Long)
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Private Declare Function PostThreadMessage Lib "user32" Alias "PostThreadMessageA" (ByVal idThread As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function Thread32First Lib "kernel32.dll" (ByVal HSnapShot As Long, ByRef EntryModule As THREADENTRY32) As Long
Private Declare Function Thread32Next Lib "kernel32.dll" (ByVal HSnapShot As Long, ByRef EntryModule As THREADENTRY32) As Long


'**********************************************************
'**********************************************************
'dichiarazioni x il debug da utilizzare per visualizzare
'gl errori restituiti dal OS con API GetLastError
'Vengono usate nella routine di questo modulo:
'"Public Function CloseProcess(pID As Long) As Boolean"
'Nella routine le parti commentate non riguardanti il codice
'son tentativi di debug. Contattare bug@sasim.net per eventuali risoluzioni
'del bug "Mancato kill di IEexplorer.exe"... TNX :)
'--------------------------------------------------------------------------
'Const FORMAT_MESSAGE_ALLOCATE_BUFFER = &H100
'Const FORMAT_MESSAGE_FROM_SYSTEM = &H1000
'Const LANG_NEUTRAL = &H0
'Const SUBLANG_DEFAULT = &H1
'Const ERROR_BAD_USERNAME = 2202&
'Private Declare Sub SetLastError Lib "kernel32" (ByVal dwErrCode As Long)
'Private Declare Function GetLastError Lib "kernel32" () As Long
'Private Declare Function FormatMessage Lib "kernel32" Alias "FormatMessageA" (ByVal dwFlags As Long, lpSource As Any, ByVal dwMessageId As Long, ByVal dwLanguageId As Long, ByVal lpBuffer As String, ByVal nSize As Long, Arguments As Long) As Long
'Private Declare Function TerminateThread Lib "kernel32" (ByVal hThread As Long, ByVal dwExitCode As Long) As Long

'**********************************************************
'**********************************************************

Public Sub CaricaTask()
Dim FullFileName As String
Dim HSnapShot As Long
Dim uProcess As PROCESSENTRY32
Dim r As Long, PosSlash As Variant

HSnapShot = CreateToolhelpSnapshot(TH32CS_SNAPPROCESS, 0&)
If HSnapShot = 0 Then Exit Sub

uProcess.dwSize = Len(uProcess)
r = ProcessFirst(HSnapShot, uProcess)
frmMain.lstTask.Clear

Do While r

    FullFileName = StrConv(PulisciWord(Trim$(uProcess.szExeFile)), vbLowerCase)
    PosSlash = InStrRev(FullFileName, "\")
    If PosSlash > 0 Then
        FullFileName = Mid$(FullFileName, PosSlash + 1, Len(FullFileName) - PosSlash)
    End If
    If FullFileName <> "svchost.exe" And FullFileName <> "system" And FullFileName <> "services.exe" And _
        FullFileName <> "[system process]" And FullFileName <> "csrss.exe" And FullFileName <> "lsass.exe" _
        And FullFileName <> "smss.exe" And FullFileName <> "winlogon.exe" And FullFileName <> "explorer.exe" _
        And FullFileName <> "dllhost.exe" And FullFileName <> "msdtc.exe" And FullFileName <> "alg.exe" _
        And FullFileName <> "spoolsv.exe" And FullFileName <> "systray.exe" And FullFileName <> "kernel32.dll" _
        And FullFileName <> "mmtask.tsk" And FullFileName <> "msgsrv32.exe" And FullFileName <> "wmiexe.exe" _
        And FullFileName <> "mprexe.exe" Then
            frmMain.lstTask.AddItem FullFileName
            frmMain.lstTask.ItemData(frmMain.lstTask.NewIndex) = uProcess.th32ProcessID
            'Debug.Print Hex(uProcess.th32ProcessID) & " " & FullFileName
    End If
        
    uProcess.szExeFile = ""
    r = ProcessNext(HSnapShot, uProcess)
Loop ' Do all the processs
Call CloseHandle(HSnapShot)
End Sub
Public Function CloseProcess(pID As Long) As Boolean
Dim EntryThread     As THREADENTRY32
Dim HSnapShot       As Long
Dim Esito           As Long
'Dim Buffer          As String
Dim ret             As Long

'Buffer = Space(200)

CloseProcess = False
HSnapShot = CreateToolhelpSnapshot(TH32CS_SNAPTHREAD, pID) ' Estraggo tutti i threads del processo, e a tutti invio un WM_QUIT
If HSnapShot <> -1 Then
    EntryThread.dwSize = Len(EntryThread)
    Esito = Thread32First(HSnapShot, EntryThread)
    Do While Esito
        If EntryThread.th32OwnerProcessID = pID Then
            CloseProcess = True
            ' invio il messaggio di chiusura
            ret = PostThreadMessage(EntryThread.th32ThreadID, WM_QUIT, 0, 0)
            
        'Debug.Print ret
        'If ret = 0 Then Debug.Print TerminateThread(EntryThread.th32ThreadID, 0)
        
        'FormatMessage FORMAT_MESSAGE_FROM_SYSTEM, ByVal 0&, GetLastError, LANG_NEUTRAL, Buffer, 200, ByVal 0&
        'Debug.Print EntryThread.th32OwnerProcessID & "  " & EntryThread.th32ThreadID & "  " & Buffer
        
        'Buffer = "": Buffer = Space(200)
        
        End If
        Esito = Thread32Next(HSnapShot, EntryThread)
    Loop
    Call CloseHandle(HSnapShot)
End If

End Function
Public Function PulisciWord(ByRef Parola As String) As String
'Pulisce la stringa da caratteri indesiderati... < 10 in ASCII
Dim i As Long
Dim tmp As String
Dim NewWord As String
For i = 1 To Len(Parola)
    tmp = Mid$(Parola, i, 1)
    If Asc(tmp) > 10 Then NewWord = NewWord & tmp
Next i
PulisciWord = NewWord
End Function
